//
//  FeedListCoordinator.swift
//  ReviewsFeed
//
//  Created by Javier Cicchelli on 21/03/2024.
//  Copyright © 2024 Röck+Cöde. All rights reserved.
//

import Foundation
import ReviewsCoordinationKit

public final class FeedListCoordinator: Coordinator {
    
    // MARK: Constants
    public let router: any Router
    
    private let sessionConfiguration: URLSessionConfiguration
    
    // MARK: Properties
    public var children: [any Coordinator] = []
    
    // MARK: Initialisers
    public init(
        router: any Router,
        sessionConfiguration: URLSessionConfiguration = .ephemeral
    ) {
        self.router = router
        self.sessionConfiguration = sessionConfiguration
    }
    
    // MARK: Functions
    public func present(
        animated: Bool,
        onDismiss: Router.OnDismissClosure? = nil
    ) {
        router.present(
            FeedListViewController(configuration: .init(
                session: sessionConfiguration
            )),
            animated: animated,
            onDismiss: onDismiss
        )
    }
    
}
